﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
End Sub

Sub Globals
	Private HuaweiAdsKitBanner1 As HuaweiAdsKit
	Private HuaweiAdsKitInterstitial1 As HuaweiAdsKitInterstitial
	Private HuaweiAdsKitReward1 As HuaweiAdsKitReward
	Private HuaweiAdsKitConsent1 As HuaweiAdsKitConsent
	Private RequestOptions1 As HuaweiAdsKitRequestOptions
	Private btnLoadAd As Button
	Private btnShowAd As Button
	Private btnShowConsent As Button
	Private btnRewardLoad As Button
	Private btnRewardShow As Button
	Private UserConsentStatus As Int = 2 ' Consent status for Interstitial and Reward Ads
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'***************************************************
	'***************************************************
	'
	'                CHECK MANIFEST
	'
	'***************************************************
	'***************************************************
	Activity.LoadLayout("layBanner")
	HuaweiAdsKitConsent1.Initialize("HuaweiAdsKitConsent1")
	' DO NOT USE RequestOptions1 as is in LoadAd, please read what settings to choose on this link:
	' https://developer.huawei.com/consumer/en/doc/development/HMSCore-Guides-V5/publisher-service-advanced-settings-0000001050064972-V5#EN-US_TOPIC_0000001057125168__section62661647152710
	RequestOptions1.Initialize
	HuaweiAdsKitInterstitial1.Initialize("HuaweiAdsKitInterstitial1", "testb4znbuh3n2") 'Test AdId for Video Ad = testb4znbuh3n2 - Test AdId for Image Ad = teste9ih9j0rc3
	HuaweiAdsKitReward1.Initialize("HuaweiAdsKitReward1", "testx9dtjwj8hp")	
	HuaweiAdsKitBanner1.Initialize("HuaweiAdsKitBanner1", "testw6vs28auh3", HuaweiAdsKitBanner1.BANNER_SIZE_320_50)
	Activity.AddView(HuaweiAdsKitBanner1, 50%x-160dip, 0, 320dip, 50dip)
	btnShowAd.Enabled = False
	btnRewardShow.Enabled = False
End Sub

Sub Activity_Resume
	' This line with code as it is, will trigger Consent dialog on each Activity_Resume, you can set DebugMode to False or HuaweiAdsKitConsent1.DEBUG_NOT_NEED_CONSENT
	' DebugMode - if is True second and third parameters will be applied, if it is False, second and third parameters will be ignored.
	HuaweiAdsKitConsent1.CheckConsentStatus(True, HuaweiAdsKitConsent1.DEBUG_NEED_CONSENT, HuaweiAdsKitConsent1.CONSENT_STATUS_UNKNOWN)
	
	' Call HuaweiAdsKitBanner1.Resume if you don't use HuaweiAdsKitConsent. If you use HuaweiAdsKitConsent then in event HuaweiAdsKitConsent1_UpdateConsentStatus ad will be loaded.
	' HuaweiAdsKitBanner1.Resume 
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	HuaweiAdsKitBanner1.Pause
End Sub

Sub btnShowConsent_Click
	UserConsentStatus = 2
	HuaweiAdsKitConsent1.SetConsentStatus(HuaweiAdsKitConsent1.CONSENT_STATUS_UNKNOWN)
	HuaweiAdsKitConsent1.CheckConsentStatus(True, HuaweiAdsKitConsent1.DEBUG_NEED_CONSENT, HuaweiAdsKitConsent1.CONSENT_STATUS_UNKNOWN)
End Sub

Sub HuaweiAdsKitConsent1_ConsentStatusFailed (Error As String)
	Log ("ConsentStatusFailed - Error: " & Error)
	' If status Failed then load NON_PERSONALIZED ads.
	' More on link: https://developer.huawei.com/consumer/en/doc/development/HMS-Guides/ads-sdk-settings#h2-1576130322488
	HuaweiAdsKitBanner1.LoadAd(30, False, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
	UserConsentStatus = 1
End Sub

Sub HuaweiAdsKitConsent1_NeedConsent (AdProviders As Map)
	Log ("NeedConsent - we will show Consent dialog")
	Dim AdProvidersText As String = ""
	If AdProviders.Size > 0 Then
		For i = 0 To AdProviders.Size - 1
			Dim OneAdProvider As String = "<strong><a href=""" & AdProviders.GetValueAt(i) & """>" & AdProviders.GetKeyAt(i) & "</a></strong><br />"
			AdProvidersText = AdProvidersText & OneAdProvider
		Next
	End If
	ShowConsentDialog(AdProvidersText)
End Sub

Sub HuaweiAdsKitConsent1_NotNeedConsent (ConsentStatus As Int)
	' PERSONALIZED = 0
	' NON_PERSONALIZED = 1
	' UNKNOWN = 2
	'
	' As we dont need to show consent to this user, we can show personalized ads
	Log ("NotNeedConsent - ConsentStatus: " & ConsentStatus & ". You can ignore this consent status and show personalized ads as Consent from user is not needed.")
	HuaweiAdsKitBanner1.LoadAd(30, True, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
	UserConsentStatus = 0
End Sub

'*************************************************************
'*************************************************************
'*************************************************************
'      IMPORTANT!   IMPORTANT!   IMPORTANT!   IMPORTANT!  
'      IMPORTANT!   IMPORTANT!   IMPORTANT!   IMPORTANT! 
'      IMPORTANT!   IMPORTANT!   IMPORTANT!   IMPORTANT!  
'
' ShowConsentDialog will show HTML file with name: consent.html
' consent.html file is inside Files folder.

' DO NOT USE CONSENT FILE AS IS, you need to change some text. As you
' can see inside file, text contain "HuaweiAdsSdk_Demo" and also "Demo description" 
' and "This demo is for reference only. Modify the content based on the user protocol specifications."
'
' You need to carefully read text and modify text for your needs.
' Huawei not provided any text for developers, just demo text as you can see inside file.
'*************************************************************
'*************************************************************
'*************************************************************
Sub ShowConsentDialog (AdProvidersText As String)
	Dim dialog As CustomLayoutDialog
	Dim consent As Object = dialog.ShowAsync("", "Agree", "", "Skip", Null, False)
	Wait For (consent) Dialog_Ready (DialogPanel As Panel)
	DialogPanel.LoadLayout("layconsent")
	Dim WebViewConsent As WebView = DialogPanel.GetView(0)
	WebViewConsent.ZoomEnabled = False
	Dim ConsentText As String = File.GetText(File.DirAssets, "consent.html")
	ConsentText = ConsentText.Replace("{APP_NAME}", Application.LabelName).Replace("{AD_PROVIDER_LIST}", AdProvidersText)
	WebViewConsent.LoadHtml(ConsentText)
	Wait For (consent) Dialog_Result (Result As Int)
	If Result = DialogResponse.POSITIVE Then
		Log("Load Personalized Ad")
		HuaweiAdsKitConsent1.SetConsentStatus(HuaweiAdsKitConsent1.CONSENT_STATUS_PERSONALIZED)
		HuaweiAdsKitBanner1.LoadAd(30, True, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
		UserConsentStatus = 0
	Else If Result = DialogResponse.NEGATIVE Then
		Log("Load Non Personalized Ad")
		HuaweiAdsKitConsent1.SetConsentStatus(HuaweiAdsKitConsent1.CONSENT_STATUS_NON_PERSONALIZED)
		HuaweiAdsKitBanner1.LoadAd(30, False, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
		UserConsentStatus = 1
	End If
End Sub

Sub WebViewConsent_OverrideUrl (Url As String) As Boolean
	If Url.ToUpperCase = "HTTP://HUAWEI_OAID_SETTING/" Then ' DO NOT EDIT THIS LINK IN consent.html file as it starts Intent
		Dim i As Intent
		i.Initialize("com.huawei.hms.action.OAID_SETTING", "")
		StartActivity(i)
	Else If Url.ToUpperCase = "HTTP://HUAWEI_SIMPLE_PRIVACY/" Then  ' DO NOT EDIT THIS LINK IN consent.html file as it starts Intent
		Dim i As Intent
		i.Initialize("com.huawei.hms.ppskit.ACTION.SIMPLE_PRIVACY", "")
		StartActivity(i)
	Else
		Dim p As PhoneIntents
		StartActivity(p.OpenBrowser(Url))
	End If
	Return True
End Sub

Sub HuaweiAdsKitConsent1_UpdateConsentStatus (ConsentStatus As Int)
	' PERSONALIZED = 0
	' NON_PERSONALIZED = 1
	' UNKNOWN = 2
	Log ("UpdateConsentStatus - ConsentStatus: " & ConsentStatus)
	If ConsentStatus = 0 Then
		HuaweiAdsKitBanner1.LoadAd(30, True, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
		UserConsentStatus = 0
	Else if ConsentStatus = 1 Then
		HuaweiAdsKitBanner1.LoadAd(30, False, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
		UserConsentStatus = 1
	Else
		UserConsentStatus = 2
		Log ("ConsentStatus is UNKNOWN we will skip ad loading." )
	End If
End Sub

Sub HuaweiAdsKitBanner1_AdClicked
	Log("Banner AdClicked")
End Sub

Sub HuaweiAdsKitBanner1_AdClosed
	Log("Banner AdClosed")
End Sub

Sub HuaweiAdsKitBanner1_AdFailed (Error As String)
	Log("Banner AdFailed: " & Error) ' Error codes description on link: https://developer.huawei.com/consumer/en/doc/development/HMS-Guides/ads-sdk-faq
End Sub

Sub HuaweiAdsKitBanner1_AdLeave
	Log("Banner AdLeave")
End Sub

Sub HuaweiAdsKitBanner1_AdLoaded
	Log("Banner AdLoaded")
End Sub

Sub HuaweiAdsKitBanner1_AdOpened
	Log("Banner AdOpened")
End Sub




' Code for Interstitials Ads

Sub btnLoadAd_Click
	If UserConsentStatus = 0 Then
		HuaweiAdsKitInterstitial1.LoadAd(True, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
	Else if UserConsentStatus = 1 Then
		HuaweiAdsKitInterstitial1.LoadAd(False, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
	Else
		Log ("ConsentStatus is UNKNOWN we will skip interstitial ad loading." )
	End If
End Sub

Sub btnShowAd_Click
	If HuaweiAdsKitInterstitial1.IsLoaded Then
		HuaweiAdsKitInterstitial1.ShowAd
	End If
End Sub

Sub HuaweiAdsKitInterstitial1_AdClicked
	Log("Interstitial AdClicked")
End Sub

Sub HuaweiAdsKitInterstitial1_AdClosed
	Log("Interstitial AdClosed")
End Sub

Sub HuaweiAdsKitInterstitial1_AdFailed (Error As String)
	Log("Interstitial AdFailed: " & Error) ' Error codes description on link: https://developer.huawei.com/consumer/en/doc/development/HMS-Guides/ads-sdk-faq
	btnLoadAd.Enabled = True
	btnShowAd.Enabled = False
End Sub

Sub HuaweiAdsKitInterstitial1_AdLoaded
	Log("Interstitial AdLoaded")
	btnLoadAd.Enabled = False
	btnShowAd.Enabled = True
End Sub

Sub HuaweiAdsKitInterstitial1_AdImpression
	Log("Interstitial AdImpression") ' I did not see this event fire (maybe just in some specific circumstances)
End Sub

Sub HuaweiAdsKitInterstitial1_AdLeave
	Log("Interstitial AdLeave")
End Sub

Sub HuaweiAdsKitInterstitial1_AdOpened
	Log("Interstitial AdOpened")
	btnLoadAd.Enabled = True
	btnShowAd.Enabled = False
End Sub




' Code for Reward Ads

Sub btnRewardLoad_Click
	If UserConsentStatus = 0 Then
		HuaweiAdsKitReward1.LoadAd(True, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
	Else if UserConsentStatus = 1 Then
		HuaweiAdsKitReward1.LoadAd(False, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
	Else
		Log ("ConsentStatus is UNKNOWN we will skip reward ad loading." )
	End If
End Sub

Sub btnRewardShow_Click
	If HuaweiAdsKitReward1.IsLoaded Then
		HuaweiAdsKitReward1.ShowAd
	End If
End Sub

Sub HuaweiAdsKitReward1_RewardedLoaded
	Log("RewardedLoaded")
	btnRewardLoad.Enabled = False
	btnRewardShow.Enabled = True
End Sub

Sub HuaweiAdsKitReward1_RewardAdFailedToLoad (Error As String)
	Log("RewardAdFailedToLoad: " & Error) ' Error codes description on link: https://developer.huawei.com/consumer/en/doc/development/HMS-Guides/ads-sdk-faq
	btnRewardLoad.Enabled = True
	btnRewardShow.Enabled = False
End Sub

Sub HuaweiAdsKitReward1_RewardAdOpened
	Log("RewardAdOpened")
	btnRewardLoad.Enabled = True
	btnRewardShow.Enabled = False
End Sub

Sub HuaweiAdsKitReward1_RewardAdClosed
	Log("RewardAdClosed")
End Sub

Sub HuaweiAdsKitReward1_RewardAdFailedToShow (Error As String)
	Log("RewardAdFailedToShow: " & Error)
	btnRewardLoad.Enabled = True
	btnRewardShow.Enabled = False
End Sub

Sub HuaweiAdsKitReward1_Rewarded (RewardName As String, RewardAmount As Int)
	Log("Reward name: " & RewardName)
	Log("Reward amount: " & RewardAmount)
End Sub


