﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Private HuaweiAdsKitSmartBanner1 As HuaweiAdsKit
	Private RequestOptions1 As HuaweiAdsKitRequestOptions
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = "Smart Banner Test"	
	RequestOptions1.Initialize
	HuaweiAdsKitSmartBanner1.Initialize("HuaweiAdsKitSmartBanner1", "testw6vs28auh3", HuaweiAdsKitSmartBanner1.BANNER_SIZE_SMART)
	Dim SmartBannerHeight As Int ' More on this link: https://developer.huawei.com/consumer/en/doc/development/HMS-Guides/ads-sdk-guide-banner#h1-1587893002780
	Dim ScreenHeightScaled As Float
	ScreenHeightScaled = GetDeviceLayoutValues.Height / GetDeviceLayoutValues.Scale
	If ScreenHeightScaled <= 400 Then
		SmartBannerHeight = 32dip
		Log("SmartBannerHeight = 32dip")
	Else if ScreenHeightScaled > 400 And ScreenHeightScaled <= 720 Then
		SmartBannerHeight = 50dip
		Log("SmartBannerHeight = 50dip")
	Else if ScreenHeightScaled > 720 Then
		SmartBannerHeight = 90dip
		Log("SmartBannerHeight = 90dip")		
	End If
	Activity.AddView(HuaweiAdsKitSmartBanner1, 0dip, 100%y - SmartBannerHeight, 100%x, SmartBannerHeight)
	HuaweiAdsKitSmartBanner1.LoadAd(30, True, RequestOptions1.AD_CONTENT_CLASSIFICATION_W, RequestOptions1.TAG_FOR_UNDER_AGE_PROMISE_TRUE, RequestOptions1.TAG_FOR_CHILD_PROTECTION_TRUE)
End Sub

Sub Activity_Resume
	HuaweiAdsKitSmartBanner1.Resume ' Call resume if you don't use HuaweiAdsKitConsent
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	HuaweiAdsKitSmartBanner1.Pause
End Sub

Sub HuaweiAdsKitSmartBanner1_AdClicked
	Log("AdClicked")
End Sub

Sub HuaweiAdsKitSmartBanner1_AdClosed
	Log("AdClosed")
End Sub

Sub HuaweiAdsKitSmartBanner1_AdFailed (Error As String)
	Log("AdFailed: " & Error) ' Error codes description on link: https://developer.huawei.com/consumer/en/doc/development/HMS-Guides/ads-sdk-faq
End Sub

Sub HuaweiAdsKitSmartBanner1_AdLeave
	Log("AdLeave")
End Sub

Sub HuaweiAdsKitSmartBanner1_AdLoaded
	Log("AdLoaded")
End Sub

Sub HuaweiAdsKitSmartBanner1_AdOpened
	Log("AdOpened")
End Sub


